//+------------------------------------------------------------------+
//|                                                         iCCx.mq4 |
//|                                         Copyright  2013, figar0 |
//|                                                   figaro@mail.ru |
//+------------------------------------------------------------------+


//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 8
#property  indicator_color1  Green
#property  indicator_color2  DarkBlue
#property  indicator_color3  Red
#property  indicator_color4  Chocolate
#property  indicator_color5  Maroon
#property  indicator_color6  DarkOrange
#property  indicator_color7  Purple
#property  indicator_color8  Teal
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1
#property  indicator_width4  1
#property  indicator_width5  1
#property  indicator_width6  1
#property  indicator_width7  1
#property  indicator_width8  1

extern double GravityPercent = 10; //0-100
extern int Price = 0; //0-close, 1-Open, 2-, 3 - 4-

int Line_Thickness = 2;

//---- indicator parameters

//---- indicator buffers
double     arrUSD[];
double     arrEUR[];
double     arrGBP[];
double     arrCHF[];
double     arrJPY[];
double     arrAUD[];
double     arrCAD[];
double     arrNZD[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexBuffer(0,arrUSD);
   SetIndexBuffer(1,arrEUR);
   SetIndexBuffer(2,arrGBP);
   SetIndexBuffer(3,arrCHF);
   SetIndexBuffer(4,arrJPY);
   SetIndexBuffer(5,arrAUD);
   SetIndexBuffer(6,arrCAD);
   SetIndexBuffer(7,arrNZD);  
   
   SetIndexLabel(0,"USD");
   SetIndexLabel(1,"EUR");
   SetIndexLabel(2,"GBP");
   SetIndexLabel(3,"CHF");  
   SetIndexLabel(4,"JPY");
   SetIndexLabel(5,"AUD");
   SetIndexLabel(6,"CAD");
   SetIndexLabel(7,"NZD"); 
   
   SetIndexStyle(0,DRAW_LINE,EMPTY,width("USD"));
   SetIndexStyle(1,DRAW_LINE,EMPTY,width("EUR"));
   SetIndexStyle(2,DRAW_LINE,EMPTY,width("GBP"));
   SetIndexStyle(3,DRAW_LINE,EMPTY,width("CHF"));
   SetIndexStyle(4,DRAW_LINE,EMPTY,width("JPY"));  
   SetIndexStyle(5,DRAW_LINE,EMPTY,width("AUD"));  
   SetIndexStyle(6,DRAW_LINE,EMPTY,width("CAD"));  
   SetIndexStyle(7,DRAW_LINE,EMPTY,width("NZD"));   

   IndicatorShortName("Index: USD EUR GBP CHF JPY AUD CAD NZD");
   
   IndicatorDigits(5);

   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   double i1, i2;
   int limit;
   int counted_bars=IndicatorCounted();
   limit=Bars-counted_bars-1;
   for(int i=limit; i>=0; i--)
   {
     if (iTime("USDJPY",0,i+1)!=iTime("EURUSD",0,i+1) || iTime("USDCHF",0,i+1)!=iTime("EURUSD",0,i+1)
         || iTime("USDCAD",0,i+1)!=iTime("EURUSD",0,i+1) || iTime("AUDUSD",0,i+1)!=iTime("EURUSD",0,i+1)
         || iTime("GBPUSD",0,i+1)!=iTime("EURUSD",0,i+1) || iTime("NZDUSD",0,i+1)!=iTime("EURUSD",0,i+1)) continue;
     i1=MathPow((price_func("USDJPY",Price,i)/100*price_func("USDCHF",Price,i)*price_func("USDCAD",Price,i)+ 0.00001)/
      (price_func("EURUSD",Price,i)*price_func("AUDUSD",Price,i)*price_func("GBPUSD",Price,i)*price_func("NZDUSD",Price,i)+ 0.00001),1.0/7.0);
     
     i2=MathPow((price_func("USDJPY",Price,i+1)/100*price_func("USDCHF",Price,i+1)*price_func("USDCAD",Price,i+1)+ 0.00001)/
      (price_func("EURUSD",Price,i+1)*price_func("AUDUSD",Price,i+1)*price_func("GBPUSD",Price,i+1)*price_func("NZDUSD",Price,i+1) + 0.00001),1.0/7.0);
      
       arrUSD[i]=i1-i2 + arrUSD[i+1]*(1-GravityPercent/100.0);       
       
       arrEUR[i]=i1*price_func("EURUSD",Price,i)-i2*price_func("EURUSD",Price,i+1)
       + arrEUR[i+1]*(1-GravityPercent/100.0);
       
       arrGBP[i]=i1*price_func("GBPUSD",Price,i)-i2*price_func("GBPUSD",Price,i+1)
       + arrGBP[i+1]*(1-GravityPercent/100.0);
     
       arrCHF[i]=i1/(price_func("USDCHF",Price,i)+0.00001)-i2/(price_func("USDCHF",Price,i+1)+0.00001)
       + arrCHF[i+1]*(1-GravityPercent/100.0);
    
       arrJPY[i]=i1/(price_func("USDJPY",Price,i)/100+0.00001)-i2/(price_func("USDJPY",Price,i+1)/100+0.00001)
       + arrJPY[i+1]*(1-GravityPercent/100.0);
            
       arrAUD[i]=i1*price_func("AUDUSD",Price,i)-i2*price_func("AUDUSD",Price,i+1)
       + arrAUD[i+1]*(1-GravityPercent/100.0);
       
       arrCAD[i]=i1/(price_func("USDCAD",Price,i)+0.00001)-i2/(price_func("USDCAD",Price,i+1)+0.00001)
       + arrCAD[i+1]*(1-GravityPercent/100.0);
      
       arrNZD[i]=i1*price_func("NZDUSD",Price,i)-i2*price_func("NZDUSD",Price,i+1)
       + arrNZD[i+1]*(1-GravityPercent/100.0);
   
     }
   return(0);
  }
//+------------------------------------------------------------------+

double price_func(string symb, int price, int bar)
{
  double result=0;
  if (price<0 || price>4) { Print ("Incorrect price choice"); return (0); }
  if (price==0) return (iClose(symb,0,bar));
  if (price==1) return (iOpen(symb,0,bar));  
  if (price==2) return ((iHigh(symb,0,bar) + iLow(symb,0,bar))/2);  
  if (price==3) return ((iHigh(symb,0,bar) + iLow(symb,0,bar)+iClose(symb,0,bar))/3); 
  if (price==4) return ((iHigh(symb,0,bar) + iLow(symb,0,bar)+2*iClose(symb,0,bar))/4); 
}

int width (string symb)
{
   if(0 > StringFind(Symbol(), symb, 0))
       return(1);
   else 
       return(2);
}